#include <bits/stdc++.h>

//#define int long long
#define F first
#define ld long double
#define S second
using namespace std;
const int inf = 1e9;

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m, k;
    cin >> n >> m >> k;
    vector<vector<int>> g(n);
    for (int i = 0; i < m; ++i) {
        int v, u;
        cin >> v >> u;
        v--;
        u--;
        g[v].push_back(u);
        g[u].push_back(v);
    }
    vector<int> dist(n, inf);
    queue<int> q;
    vector<pair<int, int>> o;
    for (int i = 0; i < k; ++i) {
        int pi, hi;
        cin >> pi >> hi;
        pi--;
        o.emplace_back(-hi, pi);
        dist[pi] = -hi;
    }
    sort(o.begin(), o.end());
    for (auto[i, j] : o) {
        q.push(j);
    }
    int cnt = 0;
    while (!q.empty() && cnt < 1e7) {
        cnt++;
        int v = q.front();
        q.pop();
        for (int i : g[v]) {
            if (dist[i] > dist[v] + 1) {
                dist[i] = dist[v] + 1;
                q.push(i);
            }
        }
    }
    vector<int> ans;
    for (int i = 0; i < n; ++i) {
        if (dist[i] <= 0) {
            ans.push_back(i);
        }
    }
    cout << ans.size() << '\n';
    for (int i : ans) {
        cout << i + 1 << " ";
    }
    return 0;
}